"use strict";

exports.__esModule = true;
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Avatar = _interopRequireDefault(require("@material-ui/core/Avatar"));

var _ChevronLeft = _interopRequireDefault(require("@material-ui/icons/ChevronLeft"));

var _ChevronRight = _interopRequireDefault(require("@material-ui/icons/ChevronRight"));

var _ChromeReaderMode = _interopRequireDefault(require("@material-ui/icons/ChromeReaderMode"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _List = _interopRequireDefault(require("@material-ui/core/List"));

var _ListItem = _interopRequireDefault(require("@material-ui/core/ListItem"));

var _ListItemAvatar = _interopRequireDefault(require("@material-ui/core/ListItemAvatar"));

var _ListItemSecondaryAction = _interopRequireDefault(require("@material-ui/core/ListItemSecondaryAction"));

var _ListItemText = _interopRequireDefault(require("@material-ui/core/ListItemText"));

var _Paper = _interopRequireDefault(require("@material-ui/core/Paper"));

var _Person = _interopRequireDefault(require("@material-ui/icons/Person"));

var _Context = _interopRequireDefault(require("base-shell/lib/providers/Auth/Context"));

var _Context2 = _interopRequireDefault(require("base-shell/lib/providers/Config/Context"));

var _Context3 = _interopRequireDefault(require("material-ui-shell/lib/providers/Menu/Context"));

var _Context4 = _interopRequireDefault(require("material-ui-shell/lib/providers/Theme/Context"));

var _styles = require("@material-ui/core/styles");

var _clsx = _interopRequireDefault(require("clsx"));

var _ArrowDropDown = _interopRequireDefault(require("@material-ui/icons/ArrowDropDown"));

var _ArrowDropUp = _interopRequireDefault(require("@material-ui/icons/ArrowDropUp"));

var _Brightness = _interopRequireDefault(require("@material-ui/icons/Brightness4"));

var _BrightnessHigh = _interopRequireDefault(require("@material-ui/icons/BrightnessHigh"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    paper: {
      backgroundColor: theme.palette.primary.dark,
      margin: 0,
      padding: 0
    },
    listItem: {
      color: theme.palette.primary.contrastText,
      cursor: 'pointer'
    },
    icon: {
      color: theme.palette.primary.contrastText,
      cursor: 'pointer'
    },
    toolbar: _extends({
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'flex-end',
      padding: theme.spacing(0, 2)
    }, theme.mixins.toolbar)
  };
});

var MenuHeader = function MenuHeader() {
  var theme = (0, _styles.useTheme)();

  var _useContext = (0, _react.useContext)(_Context.default),
      auth = _useContext.auth;

  var _useContext2 = (0, _react.useContext)(_Context2.default),
      appConfig = _useContext2.appConfig;

  var _useContext3 = (0, _react.useContext)(_Context4.default),
      type = _useContext3.type,
      setType = _useContext3.setType;

  var _ref = appConfig || {},
      menu = _ref.menu;

  var authData = auth;
  var classes = useStyles();

  var _useContext4 = (0, _react.useContext)(_Context3.default),
      isDesktop = _useContext4.isDesktop,
      isDesktopOpen = _useContext4.isDesktopOpen,
      setDesktopOpen = _useContext4.setDesktopOpen,
      isMini = _useContext4.isMini,
      setMini = _useContext4.setMini,
      isAuthMenuOpen = _useContext4.isAuthMenuOpen,
      setAuthMenuOpen = _useContext4.setAuthMenuOpen,
      useMiniMode = _useContext4.useMiniMode;

  var isAuthenticated = auth.isAuthenticated;
  return /*#__PURE__*/_react.default.createElement(_Paper.default, {
    square: true,
    className: classes.paper
  }, isMini && isAuthenticated && /*#__PURE__*/_react.default.createElement("div", {
    className: classes.toolbar
  }), /*#__PURE__*/_react.default.createElement(_List.default, {
    className: (0, _clsx.default)(!isAuthenticated && classes.toolbar)
  }, /*#__PURE__*/_react.default.createElement(_ListItem.default, {
    className: classes.listItem
  }, isAuthenticated && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, authData.photoURL && /*#__PURE__*/_react.default.createElement(_ListItemAvatar.default, {
    onClick: function onClick() {
      setAuthMenuOpen(!isAuthMenuOpen);
    }
  }, /*#__PURE__*/_react.default.createElement(_Avatar.default, {
    src: authData.photoURL,
    alt: "user"
  })), !authData.photoURL && /*#__PURE__*/_react.default.createElement(_ListItemAvatar.default, {
    onClick: function onClick() {
      setAuthMenuOpen(!isAuthMenuOpen);
    }
  }, /*#__PURE__*/_react.default.createElement(_Avatar.default, null, authData.displayName ? authData.displayName[0].toUpperCase() : /*#__PURE__*/_react.default.createElement(_Person.default, null)))), !isMini && /*#__PURE__*/_react.default.createElement(_ListItemSecondaryAction.default, null, /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    onClick: function onClick() {
      setType(type === 'light' ? 'dark' : 'light');
    }
  }, type === 'light' && /*#__PURE__*/_react.default.createElement(_Brightness.default, {
    classes: {
      root: classes.icon
    }
  }), type === 'dark' && /*#__PURE__*/_react.default.createElement(_BrightnessHigh.default, {
    classes: {
      root: classes.icon
    }
  })), isDesktop && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, useMiniMode && /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    onClick: function onClick() {
      setMini(true);
      setDesktopOpen(false);
    }
  }, /*#__PURE__*/_react.default.createElement(_ChromeReaderMode.default, {
    classes: {
      root: classes.icon
    }
  })), /*#__PURE__*/_react.default.createElement(_IconButton.default, {
    color: "inherit",
    onClick: function onClick() {
      setDesktopOpen(false);
    }
  }, theme.direction === 'rtl' && /*#__PURE__*/_react.default.createElement(_ChevronRight.default, {
    classes: {
      root: classes.icon
    }
  }), theme.direction !== 'rtl' && /*#__PURE__*/_react.default.createElement(_ChevronLeft.default, {
    classes: {
      root: classes.icon
    }
  })), ' '))), isAuthenticated && /*#__PURE__*/_react.default.createElement(_ListItem.default, {
    onClick: function onClick() {
      setAuthMenuOpen(!isAuthMenuOpen);
    }
  }, !isDesktopOpen && isDesktop && authData.photoURL && /*#__PURE__*/_react.default.createElement(_ListItemAvatar.default, null, /*#__PURE__*/_react.default.createElement(_Avatar.default, {
    src: authData.photoURL,
    alt: "person",
    style: {
      marginLeft: -7,
      marginTop: 3
    }
  })), !isMini && /*#__PURE__*/_react.default.createElement(_ListItemText.default, {
    classes: {
      primary: classes.listItem,
      secondary: classes.listItem
    },
    style: {
      marginLeft: !isDesktopOpen && isDesktop && authData.photoURL ? 7 : undefined
    },
    primary: authData.displayName,
    secondary: authData.email
  }), isDesktopOpen && /*#__PURE__*/_react.default.createElement(_ListItemSecondaryAction.default, {
    onClick: function onClick() {
      setAuthMenuOpen(!isAuthMenuOpen);
    }
  }, /*#__PURE__*/_react.default.createElement(_IconButton.default, null, isAuthMenuOpen && /*#__PURE__*/_react.default.createElement(_ArrowDropUp.default, {
    classes: {
      root: classes.icon
    }
  }), !isAuthMenuOpen && /*#__PURE__*/_react.default.createElement(_ArrowDropDown.default, {
    classes: {
      root: classes.icon
    }
  }))))));
};

var _default = MenuHeader;
exports.default = _default;
module.exports = exports.default;