"use strict";

exports.__esModule = true;
exports.default = _default;

var _react = _interopRequireWildcard(require("react"));

var _styles = require("@material-ui/core/styles");

var _theme = _interopRequireDefault(require("material-ui-shell/lib/utils/theme"));

var _Context = _interopRequireDefault(require("base-shell/lib/providers/Config/Context"));

var _Context2 = _interopRequireDefault(require("material-ui-shell/lib/providers/Theme/Context"));

var _CssBaseline = _interopRequireDefault(require("@material-ui/core/CssBaseline"));

var _reactIosPwaPrompt = _interopRequireDefault(require("react-ios-pwa-prompt"));

var _reactIntl = require("react-intl");

var _Update = require("base-shell/lib/providers/Update");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _default(_ref) {
  var children = _ref.children;
  var intl = (0, _reactIntl.useIntl)();

  var _useContext = (0, _react.useContext)(_Context.default),
      appConfig = _useContext.appConfig;

  var _ref2 = appConfig || {},
      components = _ref2.components;

  var _ref3 = components || {},
      _ref3$UpdateDialog = _ref3.UpdateDialog,
      UpdateDialog = _ref3$UpdateDialog === void 0 ? null : _ref3$UpdateDialog;

  var _useUpdate = (0, _Update.useUpdate)(),
      isUpdateAvailable = _useUpdate.isUpdateAvailable,
      runUpdate = _useUpdate.runUpdate;

  var _useContext2 = (0, _react.useContext)(_Context2.default),
      themeID = _useContext2.themeID,
      type = _useContext2.type;

  var _ref4 = appConfig || {},
      themeConfig = _ref4.theme,
      pwa = _ref4.pwa;

  var _ref5 = pwa || {},
      useiOSPWAPrompt = _ref5.useiOSPWAPrompt,
      iOSPWAPromptProps = _ref5.iOSPWAPromptProps,
      useUpdateDialog = _ref5.useUpdateDialog;

  var _ref6 = themeConfig || {},
      _ref6$themes = _ref6.themes,
      themes = _ref6$themes === void 0 ? [] : _ref6$themes;

  var theme = (0, _theme.default)(themeID, themes, type);
  return /*#__PURE__*/_react.default.createElement(_styles.ThemeProvider, {
    theme: theme
  }, /*#__PURE__*/_react.default.createElement(_CssBaseline.default, null), children, useUpdateDialog && /*#__PURE__*/_react.default.createElement(UpdateDialog, {
    isUpdateAvailable: isUpdateAvailable,
    runUpdate: runUpdate
  }), useiOSPWAPrompt && /*#__PURE__*/_react.default.createElement(_reactIosPwaPrompt.default //debug={true}
  , _extends({
    promptOnVisit: 1,
    timesToShow: 3,
    copyTitle: intl.formatMessage({
      id: 'ios_prompt_title',
      defaultMessage: 'Add to Home Screen'
    }),
    copyClosePrompt: intl.formatMessage({
      id: 'ios_prompt_close',
      defaultMessage: 'Close'
    }),
    copyBody: intl.formatMessage({
      id: 'ios_prompt_body',
      defaultMessage: 'This website has app functionality. Add it to your home screen to use it in fullscreen and while offline.'
    }),
    copyShareButtonLabel: intl.formatMessage({
      id: 'ios_prompt_share_button',
      defaultMessage: "1) Press the 'Share' button"
    }),
    copyAddHomeButtonLabel: intl.formatMessage({
      id: 'ios_prompt_add_to_home_button',
      defaultMessage: "2) Press 'Add to Home Screen'"
    }),
    permanentlyHideOnDismiss: false
  }, iOSPWAPromptProps)));
}

module.exports = exports.default;